export default class Server {
  constructor() { }
  fetchData(url, param) {
    const URI = `${process.env.API.emsReceivable + url}`;
    return new Promise(resolve => {
      $axios
        .post(URI, param)
        .then(response => {
          resolve(response);
        })
        .catch(error => {
          let responseData = {
            dataResult: [],
            extra: "",
            msg: error.response.data.message || "服务异常，请联系管理员",
            statusCode: "-1"
          };
          resolve(responseData);
        });
    });
  }
  /**
   * 收款工作台查询
   */
  find(param = {}) {
    return this.fetchData("/receivable/findRceivablePage", param);
  }
  edit(param = {}) {
    return this.fetchData("/receivable/saveRceivable", param);
  }
  del(param = null) {
    return param && this.fetchData(`/receivable/deleteRceivable/${param}`);
  }
  modify(param = {}) {
    return param && this.fetchData(`/receivable/updateReceivableStatus`, param);
  }
  findRelLineNumberList(param = {}) {
    return this.fetchData("/receivable/findRelLineNumberList", param);
  }
  deleteRelLineNumberList(param = null) {
    return param && this.fetchData(`/receivable/deleteRelLineNumberList/${param.receivablesRelLineNumber}`);
  }
  //导出结果
  exportResult(param = null) {
    let url = `${process.env.API.emsReceivable}/receivableExcel/commonExcelExport`;
    return new Promise(resolve => {
      $axios({
        method: 'post',
        url: url,
        data: param,
        responseType: 'blob'
      }).then(response => {
        resolve(response);
      })
        .catch(error => {
          let fr = new FileReader();
          fr.readAsText(error.response.data, 'utf-8');
          fr.onload = function (e) {
            console.info(fr.result);
            let ms = fr.result && JSON.parse(fr.result);
            let responseData = {
              dataResult: [],
              extra: "",
              msg: ms.message || "服务异常，请联系管理员",
              statusCode: "-1"
            };
            resolve(responseData);
          };
        });
    });
    // return this.fetchData("/receivableExcel/excelExportReceivable",param);
  }
  downloadTemplate(params = {}) {
    let url = `${process.env.API.emsReceivable}/receivableExcel/excelExportHandworkTemplate`
    // return window.open(url,'_blank'); 
    return new Promise(resolve => {
      $axios({
        method: 'post',
        url: url,
        data: params,
        responseType: 'blob'
      }).then(response => {
        resolve(response);
      })
        .catch(error => {
          let fr = new FileReader();
          fr.readAsText(error.response.data, 'utf-8');
          fr.onload = function (e) {
            console.info(fr.result);
            let ms = fr.result && JSON.parse(fr.result);
            let responseData = {
              dataResult: [],
              extra: "",
              msg: ms.message || "服务异常，请联系管理员",
              statusCode: "-1"
            };
            resolve(responseData);
          };
        });
    });
  }
  loadFileMsg(params = {}) {
    return this.fetchData(`/receivableExcel/excelImportReceivableLogPage`, params);
  }
  loadFileError(id) {
    let url = `${process.env.API.emsReceivable}/receivableExcel/excelImportReceivableLogFile/${id}`;
    return window.open(url, '_blank');
    // return new Promise(resolve => { 
    //   $axios({
    //     method:'post',
    //     url:url,
    //     responseType:'blob'
    //   }).then(response => { 
    //     resolve(response);
    //   })
    //   .catch(error => {
    //     let responseData = {
    //       dataResult: [],
    //       extra: "",
    //       msg: error.response.data.message || "服务异常，请联系管理员",
    //       statusCode: "-1"
    //     };
    //     resolve(responseData);
    //   });
    // }); 
  }

  imageObtainUrl(param = {}) {
    return this.fetchData(`/imageController/imageObtainUrl?receivablesNum=${param.receivablesNum}`, param)
  }

  imagerReadingUrlVO(param = {}) {
    return this.fetchData(`/imageController/imagerReadingUrlVO?receivablesNum=${param.receivablesNum}`, param)
  }

}
