export default class Server {
  constructor() {}
  fetchData(url, param) {
    const URI = `${process.env.API.emsReceivable + url}`;
    return new Promise(resolve => {
      $axios
        .post(URI, param)
        .then(response => {
          resolve(response);
        })
        .catch(error => {
          let responseData = {
            dataResult: [],
            extra: "",
            msg: error.response.data.message || "服务异常，请联系管理员",
            statusCode: "-1"
          };
          resolve(responseData);
        });
    });
  }
  /**
   * 收款工作台查询
   */
  find(param = {}) {
    // return this.fetchData('/cert/findImpFailRceivablePage',param);
    return this.fetchData('/receivableClaim/findReceivableLinePage',param);
  } 
  //2018/12/27 修改  EMS-3158
  // updateStatus(param = null){
  //   return param && this.fetchData('/receivableClaim/backoutRceivableLine',param);
  // }
  //退回//2018/12/27 修改  EMS-3158
  updateStatus(param = null){
    return param &&this.fetchData(`/receivableClaim/updateReceivableLineStatus`,param);
  }
  reimport(param = {}){
    return param && this.fetchData(`/cert/reimport`,param);
  }
    /**
     * 收款工作台查询
     */
    findDetail(param = {}) {
        return param && this.fetchData(`/cert/findImpFailDetail/${param}`);
    }
    /**
     * 导出文件
     * @param param
     * @returns {Promise<any>}
     */
    exportResult(param = null){
        let url = `${process.env.API.emsReceivable}/receivableExcel/commonExcelExport`;
        return new Promise(resolve => { $axios({
            method:'post',
            url:url,
            data:param,
            responseType:'blob'
        }).then(response => {
            resolve(response);
        })
            .catch(error => {
              let fr = new FileReader();
              fr.readAsText(error.response.data,'utf-8');
              fr.onload = function(e){ 
                console.info(fr.result);
                let ms= fr.result && JSON.parse(fr.result);
                let responseData = {
                  dataResult: [],
                  extra: "",
                  msg: ms.message || "服务异常，请联系管理员",
                  statusCode: "-1"
                };
                resolve(responseData);
              }; 
            });
        });
    }
}
