import OperationRecord from './operationRecord.vue';
import DocumentInfoDetail from "./documentInfoDetail/index.vue";
import FileDetail from '../receivablesClaim/components/file/fileDetail.vue';
import util from "@/tools/util.js";
import ManuallyAddEditPage from "ems-receivable@/views/ems/manuallyAdd/edit.vue";
import Server from "./server";

const server = new Server

class TableConfig {
  constructor(vm, arr) {
    this.vm = vm;
    this.columnArr = arr;
    this.CodesVal = new Map();
    this.columnsMap = new Map();
    //初始化值集
    this.create();
  }
  create() {
    this._initialColumns();
  }
  // //初始化需要的信息
  // _initialData(){
  //   //初始化值集信息
  //   let codes = ["currency","ReceivablesPaymentType","ReceivablesSource","ReceivablesStatus","ReceivablesClass"];
  //   let arr = codes.map(async item=>{
  //     let result =await this.vm.$store.dispatch("GetValueSetByCode",{code:item}); 
  //     return result.dataResult; 
  //   });
  //   let maps= new Map();
  //   for(let i =0 ;i<codes;i++){
  //     maps.set(codes[i],arr[i]);
  //   }
  //   return this._initialColumns(maps);
  // }
  _initialColumns() {
    this.columnsMap = new Map().
      set('查看', {
        title: "查看",
        align: "center",
        key: "",
        minWidth: 80,
        render: (h, params) => {
          let self = this.vm;
          return h('a', {
            on: {
              click: () => {
                new self.$sidelipPage(
                  ManuallyAddEditPage,
                  {
                    props: {
                      full: false,
                      isNav: true,
                      detail: params.row,
                      readonly: true
                    }
                  },
                  data => {
                  }
                );
              }
            }
          }, '查看')
        }
      }).
      set("imp原收款单号", {
        title: "原收款单号",
        align: "center",
        key: "parentCode",
        minWidth: 220,
        render: (h, params) => {
          let val = params.row.parentCode;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("imp收款单号", {
        title: "收款单号",
        align: "center",
        key: "receivablesNum",
        minWidth: 220,
        render: (h, params) => {
          let val = params.row.receivablesNum;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      }).set("批次号", {
        title: "批次号",
        align: "center",
        key: "batchNum",
        minWidth: 200,
        render: (h, params) => {
          let val = params.row.batchNum;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      }).set("原收款单号", {
        title: "原收款单号",
        align: "center",
        key: "receivablesNum",
        minWidth: 220,
        render: (h, params) => {
          let val = params.row.receivablesNum;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("收款单号", {
        title: "收款单号",
        align: "center",
        key: "receivablesLineNum",
        minWidth: 220,
        render: (h, params) => {
          let val = params.row.receivablesLineNum;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("业务类型", {
        title: "业务类型",
        align: "center",
        key: "categoryName",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.categoryName;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("推送情况", {
        title: "推送情况",
        align: "center",
        key: "isPush",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.isPush;
          if (params.row.isPush == "Y") {
            val = "已推送"
          } else {
            val = "未推送"
          }
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("收款单位", {
        title: "收款单位",
        align: "center",
        key: "compName",
        width: 200,
        render: (h, params) => {
          let val = params.row.compName;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("收款账号", {
        title: "收款账号",
        align: "center",
        key: "receivablesBankNum",
        width: 150,
        render: (h, params) => {
          let val = params.row.receivablesBankNum;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("付款单位", {
        title: "付款单位",
        align: "center",
        key: "paymentCompName",
        width: 150,
        render: (h, params) => {
          let val = params.row.paymentCompName;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("付款账号", {
        title: "付款账号",
        align: "center",
        key: "paymentBankNum",
        width: 150,
        render: (h, params) => {
          let val = params.row.paymentBankNum;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("供应商", {
        title: "供应商",
        align: "center",
        key: "vendorName",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.vendorName;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("供应商地点", {
        title: "供应商地点",
        align: "center",
        key: "vendorSiteName",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.vendorSiteName;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("地点", {
        title: "地点",
        align: "center",
        key: "vendorSiteName",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.vendorSiteName;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("收款金额", {
        title: "收款金额",
        align: "center",
        key: "receivablesAmount",
        width: 80,
        render: (h, params) => {
          let val = params.row.receivablesAmount;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
        // render: (h, params) => {
        //   // let val = params.row.receivablesDate ? miment().format("YYYY-MM-DD",params.row.receivablesDate):"";
        //   let val = params.row.receivablesStartAmount + "-" + params.row.receivablesEndAmount;
        //   return h(
        //     "div",
        //     {
        //       attrs: {
        //         class: "ivu-table-cell ivu-table-cell-ellipsis",
        //         title: val
        //       }
        //     },
        //     val
        //   );
        // }
      })
      .set("已认领金额", {
        title: "已认领金额",
        align: "center",
        key: "claimedAmount",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.claimedAmount;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("认领金额", {
        title: "认领金额",
        align: "center",
        key: "claimedAmount",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.claimedAmount;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("可认领金额", {
        title: "可认领金额",
        align: "center",
        key: "unclaimedAmount",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.unclaimedAmount;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("收款币种", {
        title: "收款币种",
        align: "center",
        key: "currencyName",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.currencyName;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("收款日期", {
        title: "收款日期",
        align: "center",
        key: "receivablesDate",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.receivablesDate;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
        // render: (h, params) => {
        //   // let val = params.row.receivablesDate ? miment().format("YYYY-MM-DD",params.row.receivablesDate):"";
        //   let val = params.row.receivablesStartDate + "-" + params.row.receivablesEndDate;
        //   return h(
        //     "div",
        //     {
        //       attrs: {
        //         class: "ivu-table-cell ivu-table-cell-ellipsis",
        //         title: val
        //       }
        //     },
        //     val
        //   );
        // }
      })
      .set("收款方式", {
        title: "收款方式",
        align: "center",
        key: "paymentTypeName",
        minWidth: 100,
        code: 'ReceivablesPaymentType',
        render: (h, params) => {
          let val = params.row.paymentTypeName;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("收款来源", {
        title: "收款来源",
        align: "center",
        key: "receivablesSource",
        minWidth: 100,
        render: (h, params) => {
          let vm = this.vm;
          if (!params.row.receivablesSource || !vm.$refs.searchItem) {
            return h();
          }
          let val = vm.$refs.searchItem.dataSet.ReceivablesSource[params.row.receivablesSource];
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("操作人", {
        title: "操作人",
        align: "center",
        key: "updatedByName",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.updatedByName;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      }).set("收款工作台查询--收款状态", {
        title: "收款状态",
        align: "center",
        key: "receivablesAllStatus",
        minWidth: 100,
        code: "receivablesAllStatus",
        render: (h, params) => {
          let vm = this.vm;
          if (!params.row.receivablesAllStatus) return '';
          let val = vm.$refs.searchItem.dataSet.receivablesAllStatus[params.row.receivablesAllStatus];
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("收款工作台查询--收款复核分类工作台", {
        title: "收款状态",
        align: "center",
        key: "receivablesStatus",
        minWidth: 100,
        code: "receivablesStatus",
        render: (h, params) => {
          let vm = this.vm;
          if (!params.row.receivablesStatus) return '';
          let val = vm.$refs.searchItem.dataSet.receivablesAllStatus[params.row.receivablesStatus];
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("收款状态", {
        title: "收款状态",
        align: "center",
        key: "receivablesStatus",
        minWidth: 100,
        code: "ReceivablesStatus",
        render: (h, params) => {
          let vm = this.vm;
          if (!params.row.receivablesStatus) return '';
          let val = vm.$refs.searchItem.dataSet.ReceivablesStatus[params.row.receivablesStatus];
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("主表收款状态", {
        title: "收款状态",
        align: "center",
        key: "receivablesStatus",
        minWidth: 100,
        code: "ReceivablesStatus",
        render: (h, params) => {
          let vm = this.vm;
          debugger
          if (!params.row.receivablesStatus) return '';
          let val = vm.$refs.searchItem.dataSet.ReceivableMainStatus[params.row.receivablesStatus];
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      // 
      .set("收款状态-待审批收款", {  //客户收款认领--table
        title: "收款状态",
        align: "center",
        key: "receivablesStatus",
        minWidth: 100,
        code: "ReceivablesStatus",
        render: (h, params) => {
          let val = "待审批";
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("parent收款状态", {  //客户收款认领--table
        title: "收款状态",
        align: "center",
        key: "receivablesStatus",
        minWidth: 100,
        code: "ReceivablesStatus",
        render: (h, params) => {
          let val = params.row.receivablesStatus == 5 ? "未认领" : params.row.receivablesStatus == 6 ? '部分认领' : ""
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      }).set("manuallyAdd收款状态", {  //客户收款认领--table
        title: "收款状态",
        align: "center",
        key: "receivablesStatus",
        minWidth: 100,
        code: "ReceivablesStatus",
        render: (h, params) => {
          let val = "草稿";
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      }).set("other收款状态", {  //客户收款认领--table
        title: "收款状态",
        align: "center",
        key: "receivablesStatus",
        minWidth: 100,
        code: "ReceivablesStatus",
        render: (h, params) => {
          let val = "未认领";
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("备注", {
        title: "备注",
        align: "center",
        key: "remark",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.remark;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("收款分类", {
        title: "收款分类",
        align: "center",
        key: "receivablesClass",
        minWidth: 100,
        code: "ReceivablesClass",
        render: (h, params) => {
          if (!params.row.receivablesClass) return h();
          let vm = this.vm;
          let val = vm.$refs.searchItem.dataSet.ReceivablesClass[params.row.receivablesClass];
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("手续费", {
        title: "手续费",
        align: "center",
        key: "serviceCharge",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.serviceCharge || 0;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("消息", {
        title: "消息",
        align: "center",
        key: "province",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.province;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("客户", {
        title: "客户",
        align: "center",
        key: "customerName",
        minWidth: 200,
        render: (h, params) => {
          let val = params.row.customerName;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("客户地点", {
        title: "客户地点",
        align: "center",
        key: "partySiteName",
        minWidth: 200,
        render: (h, params) => {
          let val = params.row.partySiteName;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("本次认领金额", {
        title: "本次认领金额",
        align: "center",
        key: "claimedAmount",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.claimedAmount;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("成本中心", {
        title: "成本中心",
        align: "center",
        key: "costcenterName",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.costcenterName;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("业务员", {
        title: "业务员",
        align: "center",
        key: "operatorEmpName",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.operatorEmpName;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set("金额", {
        title: "金额",
        align: "center",
        key: "province",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.province;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      // .set("退款信息", {
      //   title: "退款信息",
      //   align: "center",
      //   key: "ref",
      //   minWidth: 100
      // })
      .set("供应商", {
        title: "供应商",
        align: "center",
        key: "vendorName",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.vendorName;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set('付款方', {
        title: "付款方",
        align: "center",
        key: "paymentCompName",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.paymentCompName;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set('客户账号', {
        title: "客户账号",
        align: "center",
        key: "bankAccount",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.bankAccount;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set('流水号', {
        title: "流水号",
        align: "center",
        key: "bankSerialNumber",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.bankSerialNumber;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set('关联收款单号', {
        title: "关联收款单号",
        align: "center",
        key: "receivablesRelLineNumber ",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.receivablesRelLineNumber;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      // .set('菜单名称', {
      //     title: "菜单名称",
      //     align: "center",
      //     key: "resourceName",
      //     minWidth: 100
      // })
      // .set('菜单编码', {
      //     title: "菜单名称",
      //     align: "center",
      //     key: "resourceCode",
      //     minWidth: 100
      // })
      .set('公司名称', {
        title: "公司名称",
        align: "center",
        key: "companyName",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.companyName;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set('公司编码', {
        title: "公司编码",
        align: "center",
        key: "companyCode",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.companyCode;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set('用户姓名', {
        title: "用户姓名",
        align: "center",
        key: "userName",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.userName;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set('关联单号', {
        title: "关联单号",
        align: "center",
        key: "receivablesRelLineNumber",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.receivablesRelLineNumber;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set('用户账号', {
        title: "用户账号",
        align: "center",
        key: "userCode",
        minWidth: 100,
        render: (h, params) => {
          let val = params.row.userCode;
          return h(
            "div",
            {
              attrs: {
                class: "ivu-table-cell ivu-table-cell-ellipsis",
                title: val
              }
            },
            val
          );
        }
      })
      .set('操作记录', {
        title: "操作记录",
        align: "center",
        key: "action",
        minWidth: 80,
        render: (h, params) => {
          let self = this;
          return h('a', {
            on: {
              click: () => {
                new self.vm.$pageModal(
                  OperationRecord,
                  {
                    props: {
                      receivablesNum: params.row.receivablesNum,
                      receivablesLineNum: params.row.receivablesLineNum
                    }
                  },
                  () => { }
                );
              }
            }
          }, '操作记录')
        }
      }).
      set("关联单据",
        {
          // 3个认领复核、退回页面以及“收款工作台查询页面”，都需要添加 “关联单据”这一列，
          title: "关联单据",
          align: "center",
          key: "claimNo",
          minWidth: 200,
          render: (h, params) => {
            // let val = params.row.claimNo; 
            // if(val){
            //   return (<DocumentInfoDetail claimNo={val}></DocumentInfoDetail>);
            // }else{
            //   return;
            // } 
            let claimNo = params.row.claimNo || "";
            let self = this;
            return h("RowTools", {
              props: {
                data: [
                  {
                    text: claimNo,
                    handle: () => {
                      // claimNo && new self.vm.$pageModal(
                      //   DocumentInfoDetail,
                      //   {
                      //     props: {
                      //       claimNo:claimNo
                      //     }
                      //   },
                      //   () => {}
                      // );

                      // EMS-3735 收款认领和收款认领复核点击关联单据号时，可以超链接打开关联单据。
                      util.openRelateClaim(claimNo)
                    }
                  }
                ]
              }
            });
          }
        }).
      set("收款认领时间",
        {
          title: "收款认领时间",
          align: "center",
          key: "claimTime",
          minWidth: 150
        }).
      set("附件",
        {
          title: "附件",
          align: "center",
          key: "receivablesLineNum",
          minWidth: 60,
          render: (h, params) => {
            // 手工增加收款 查看附件取得是这个receivablesNum
            let receivablesLineNum = params.row.receivablesLineNum || params.row.receivablesNum || "";
            let self = this;
            return h("RowTools", {
              props: {
                data: [
                  {
                    text: "查看附件",
                    handle: () => {
                      new self.vm.$pageModal(
                        FileDetail,
                        {
                          props: {
                            fileNum: receivablesLineNum
                          }
                        },
                        () => { }
                      );
                    }
                  }
                ]
              }
            });
          }
        }).
      set("总账日期",
        {
          title: "总账日期",
          align: "center",
          key: "GLDate",
          width: 120,
          render: (h, params) => {
            const iptId = `GLDatePickerIpt${params.index}`
            const DatePicker = h('DatePicker', {
              props: {
                editable: false,
                clearable: false,
                transfer: true,
                format: "yyyy-MM-dd",
                value: params.row.GLDate || "",
                options: {
                  disabledDate(date) {
                    return date && date.valueOf() > Date.now();
                  }
                },
                type: "date"
              },
              domProps: {
                id: iptId
              },
              attrs: {
                placeholder: "请选择日期"
              },
              on: {
                "on-change": (fdate) => {
                  const now = new Date()
                  function push() {
                    server.updateReceivableLineGLDate({
                      receivablesLineNum: params.row.receivablesLineNum,
                      GLDate: fdate,
                    }).then(res => {
                      if (res.statusCode !== "-1") {
                        params.row.GLDate = fdate // set data
                        $app.$Message.success("总账日期修改成功！")
                      } else {
                        $app.$Message.error(`${res.msg}`)
                      }
                    })
                  }
                  
                  // ems3-ys-214 复核界面修改总账日期，没有提醒：“该总账日期不在当前月份“
                  const theipt = `#${iptId} .ivu-input`
                  const fdates = fdate.split("-")
                  if (fdates[0] != now.getFullYear()){
                    return $app.$Modal.confirm({
                      title: "确认提示",
                      content: "该总账日期不在当前年份！请确认是否继续修改？",
                      onOk(){
                        push()
                      },
                      onCancel(){
                        document.querySelector(theipt).value = params.row.GLDate || ""
                      }
                    })
                  }

                  if (fdates[1] != now.getMonth()+1) {
                    return $app.$Modal.confirm({
                      title: "确认提示",
                      content: "该总账日期不在当前月份！请确认是否继续修改？",
                      onOk: () => {
                        push()
                      },
                      onCancel() {
                        document.querySelector(theipt).value = params.row.GLDate || ""
                      }
                    })
                  }

                  push();
                }
              }
            })
            return DatePicker
          }
        }).
      set("客户/供应商",
        {
          title: "客户/供应商",
          align: "center",
          key: "customerOrVendor",
          minWidth: 150
        }).
      set("客户/供应商地点",
        {
          title: "客户/供应商地点",
          align: "center",
          key: "customerOrVendorSite",
          minWidth: 150
        })
  }
  //取出 要显示的列
  getColumns() {
    if (this.columnArr && this.columnArr.length > 0) {
      return this.columnArr.map((item) => {
        let columns = this.columnsMap.get(item);
        return columns;
      });
    } else {
      return [];
    }
  }

  getResultByCode({ arr, code, val }) {
    if (!val) return '';
    let data = arr.get(code);
    if (!data) return '';
    let result = data.filter(item => {
      if (item.vsiKey == val) {
        return item.vsiValue
      }
    });
    if (result.length > 0) {
      return result[0].vsiValue
    } else {
      return '';
    }
  }
}

export default TableConfig;