export default class Server {
  constructor() { }
  fetchData(url, param) {
    const URI = `${process.env.API.emsReceivable + url}`;
    return new Promise(resolve => {
      $axios
        .post(URI, param)
        .then(response => {
          resolve(response);
        })
        .catch(error => {
          let responseData = {
            dataResult: [],
            extra: "",
            msg: error.response.data.message || "服务异常，请联系管理员",
            statusCode: "-1"
          };
          resolve(responseData);
        });
    });
  }
  /**
   * 收款工作台查询
   */
  findFilter(param = {}) {
    return this.fetchData('/receivable/findRceivableTSSPage', param);
  }
  //导出结果
  exportResult(param = null) {
    let url = `${process.env.API.emsReceivable}/receivableExcel/commonExcelExport`;
    return new Promise(resolve => {
      $axios({
        method: 'post',
        url: url,
        data: param,
        responseType: 'blob'
      }).then(response => {
        resolve(response);
      })
        .catch(error => {
          let fr = new FileReader();
          fr.readAsText(error.response.data, 'utf-8');
          fr.onload = function (e) {
            console.info(fr.result);
            let ms = fr.result && JSON.parse(fr.result);
            let responseData = {
              dataResult: [],
              extra: "",
              msg: ms.message || "服务异常，请联系管理员",
              statusCode: "-1"
            };
            resolve(responseData);
          };
        });
    });
  }
}
