class Server {
  constructor() {

  }
  fetchData(url, param) {
    const URI = `${process.env.API.emsReceivable + url}`;
    return new Promise(resolve => {
      $axios
        .post(URI, param)
        .then(response => {
          resolve(response);
        })
        .catch(error => {
          let responseData = {
            dataResult: [],
            extra: "",
            msg: error.response.data.message || "服务异常，请联系管理员",
            statusCode: "-1"
          };
          resolve(responseData);
        });
    });
  }
  /**
   * 查询认领 
   */
  async findClaim(param = {}) {
    let data = await this.fetchData("/receivableClaim/findRceivableClaimPage", param);
    if(data.statusCode === '-1'){
      return data;
    }else{
      //数据格式化
      if(data.data.list && data.data.list.length>0){
        let list = data.data.list;
        let formatList = list.map(item=>{
          if(item.receivablesStatus&&+item.receivablesStatus === 6){
            item['_disabled']=true;
          }
          return item;
        });
        data.data.list = formatList;
      }
      return data;
    }
  }

  /**
  * 查询已认领
  * /receivableClaim/submitClaimInfor
  */
  findHavedoneClaim(param = {}) {
    return this.fetchData("/receivableClaim/findReceivablesLinePage", param);
  }
  /**
   * 查询复核
   * /receivableClaim/findReceivableLinePage
   */
  findReview(param = {}) {
    return this.fetchData("/receivableClaim/findReceivableLinePage", param);
  }
  /**
   * 复核页面的复核,退回 按钮
   * 退回页面的，提交按钮
   */
  reviewAndSignOutOperation(param = {}) { 
    return this.fetchData("/receivableClaim/updateReceivableLineStatus", param);
  }
  /**
   * 客户类收款认领---> 退回
   * 其他类收款认领---> 退回
   * 供应商类收款认领---> 退回 
   * @param {*} param 
   */
  modify_back(param = {}){
    return this.fetchData('/receivable/updateReceivableStatus',param)
  }
  /**
   * 查询退款信息table数据
   */
  findPayLineDetail(param = {}) {
    return this.fetchData("/paymentTrans/findPayLineDetail", param);
  }
  /**
   * 保存勾选的退款信息table数据
   */
  savePayLineDetail(param = {}) {
    return this.fetchData("/receivableClaim/saveRefundLineDetail", param);
  }

  /**
   * 保存新增的认领明细
   */
  submitClaimInfor(param = {}) {
    return this.fetchData("/receivableClaim/submitClaimInfor", param);
  }
  //批量认领
  submitBatchClaimInfor(param = {}) {
    return this.fetchData("/receivableClaim/submitBatchClaimInfor", param);
  }
  querySalesInfo(param = null) {
    return  this.fetchData('/receivableClaim/findSalesInfoPage', param);
  }
  //编辑
  updateClaimInfor(param = {}) {
    return this.fetchData("/receivableClaim/updateClaimInfor", param);
  }
    //导出结果
    exportResult(param = null){
        let url = `${process.env.API.emsReceivable}/receivableExcel/commonExcelExport`;
        return new Promise(resolve => { $axios({
            method:'post',
            url:url,
            data:param,
            responseType:'blob'
        }).then(response => {
            resolve(response);
        })
            .catch(error => {
              let fr = new FileReader();
              fr.readAsText(error.response.data,'utf-8');
              fr.onload = function(e){ 
                console.info(fr.result);
                let ms= fr.result && JSON.parse(fr.result);
                let responseData = {
                  dataResult: [],
                  extra: "",
                  msg: ms.message || "服务异常，请联系管理员",
                  statusCode: "-1"
                };
                resolve(responseData);
              }; 
            });
        });
    }
}
export default Server;
